/*****************************************************/
/***                GPIO library                   ***/
/***             Rui Cardoso - 2018                ***/
/*****************************************************/

package android_gpio_api;

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import anywheresoftware.b4a.BA;


@BA.ShortName("GPIO")
@BA.Version(1.1F)
public class GPIO 
{
      
    public String setValue(String pin, int value) {
    	if (value > 1) value = 1;
    	else if (value < 0) value = 0;
    	
        String cmd = String.format("echo %d > /sys/class/gpio/%s/value\n", value, pin);       
        
        try {
        	Process sh = Runtime.getRuntime().exec("sh");
        	DataOutputStream outputStream = new DataOutputStream(sh.getOutputStream());

        	outputStream.writeBytes(cmd);
        	outputStream.flush();

        	outputStream.writeBytes("exit\n");
        	outputStream.flush();
        	
        	try {
            	sh.waitFor();        	        		
        	}
            catch(InterruptedException ex) {
                //throw new Exception(ex);
                return ex.toString();
            }
        	
        	outputStream.close();        	
        	//return readGPIO(pin);
        	return "true";    
        	
        }        
        catch(IOException ex) {
            //throw new Exception(ex);
            return ex.toString();
        }
    }
    
    
    public String getValue(String pin) {
    	String cmd = String.format("cat /sys/class/gpio/%s/value\n", pin);       
        
    	try {
        	Process sh = Runtime.getRuntime().exec("sh");
        	DataOutputStream outputStream = new DataOutputStream(sh.getOutputStream());

        	outputStream.writeBytes(cmd);
        	outputStream.flush();

        	outputStream.writeBytes("exit\n");
        	outputStream.flush();
 
        	try {
            	sh.waitFor();        	        		
        	}
            catch(InterruptedException ex) {
                //throw new Exception(ex);
                return ex.toString();
            }
        	
        	outputStream.close();
           
        	BufferedReader reader = new BufferedReader(new InputStreamReader(sh.getInputStream()));
            StringBuilder value = new StringBuilder();
            String line;
            while((line = reader.readLine()) != null){
            	value.append(line);
            	value.append("\n");
            }
            return value.toString();
        } 
        catch (IOException ex) {
            return ex.toString();
        }
    }

    
    public String setDirection(String pin, String direction) {
    	if (direction != "in" && direction != "out") return "direction must be 'in' or 'out'";

    	String cmd = String.format("echo %s > /sys/class/gpio/%s/value\n", direction, pin);       
        try {
        	Process sh = Runtime.getRuntime().exec("sh");
        	DataOutputStream outputStream = new DataOutputStream(sh.getOutputStream());

        	outputStream.writeBytes(cmd);
        	outputStream.flush();

        	outputStream.writeBytes("exit\n");
        	outputStream.flush();
        	
        	try {
            	sh.waitFor();        	        		
        	}
            catch(InterruptedException ex) {
                //throw new Exception(ex);
                return ex.toString();
            }
        	
        	outputStream.close();
        	return "true";    
        	
        }        
        catch(IOException ex) {
            //throw new Exception(ex);
            return ex.toString();
        }
    }
    
    
    public String getDirection(String pin) {
    	String cmd = String.format("cat /sys/class/gpio/%s/direction\n", pin);       
        
    	try {
        	Process sh = Runtime.getRuntime().exec("sh");
        	DataOutputStream outputStream = new DataOutputStream(sh.getOutputStream());

        	outputStream.writeBytes(cmd);
        	outputStream.flush();

        	outputStream.writeBytes("exit\n");
        	outputStream.flush();
 
        	try {
            	sh.waitFor();        	        		
        	}
            catch(InterruptedException ex) {
                //throw new Exception(ex);
                return ex.toString();
            }
        	
        	outputStream.close();
           
        	BufferedReader reader = new BufferedReader(new InputStreamReader(sh.getInputStream()));
            StringBuilder direction = new StringBuilder();
            String line;
            while((line = reader.readLine()) != null){
            	direction.append(line);
            	direction.append("\n");
            }
            return direction.toString();
        } 
        catch (IOException ex) {
            return ex.toString();
        }
    }
}

