package android_uart_api;

import android.util.Log;
import anywheresoftware.b4a.BA;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

@BA.ShortName("UART")
@BA.Version(1.0F)
public class UART {
	private static final String TAG = "UART";
	private FileDescriptor mFd;
	private FileInputStream mFileInputStream;
	private FileOutputStream mFileOutputStream;
	private String mPath;
	private int mBaudrate;
	private int mFlags;
	private AsyncStreams as;
  
 
	public void Initialize(BA ba, String EventName, String path, int baudrate, int flags, boolean BigEndian, boolean Prefix) throws SecurityException, IOException {	  
		this.mFd = open(path, baudrate, flags);
		
		if (this.mFd == null) {
			Log.e(TAG, "native open returns null");
			throw new IOException();
		}
		
		this.mPath = path;
		this.mBaudrate = baudrate;
		this.mFlags = flags;
		this.mFileInputStream = new FileInputStream(this.mFd);
		this.mFileOutputStream = new FileOutputStream(this.mFd);
		
		as = new AsyncStreams();
		as.setAsyncStreams(ba, EventName, this.mFileInputStream, this.mFileOutputStream, BigEndian, Prefix);
	}
  
	
    public boolean Write(byte[] Buffer) {
    	return as.Write2(Buffer, 0, Buffer.length);
    }


    public boolean Write2(byte[] Buffer, int Start, int Length) {
    	return as.Write2(Buffer, Start, Length);
    }

    
    public String GetPath() {
    	return this.mPath;
    }
    
    
    public int GetBaudRate() {
    	return this.mBaudrate;
    }

    
    public int getFlags() {
    	return this.mFlags;
    }

    
    public InputStream getInputStream() {
    	return this.mFileInputStream;
    }
  
  
    public OutputStream getOutputStream() {	  
    	return this.mFileOutputStream;
    }
  
    
    static {
    	System.loadLibrary("UART");
    }
  
    
    private static native FileDescriptor open(String path, int baudrate, int flags);
  
    public native void close();
}
